C     A subroutine that I wrote in gradaute school that inverts an NZxNZ matrix
C     AZ is the matrix going in, and AZV is its inverse coming out.
C
      SUBROUTINE INVERT(AZ,AZV,NZ)
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION AZ(150,150),AZV(150,150),AZZ(150,150)
C
      DO 20 I=1,NZ
        DO 10 J=1,NZ
          AZZ(I,J) = AZ(I,J)
          AZV(I,J) = 0.0
   10   CONTINUE
        AZV(I,I) = 1.0
   20 CONTINUE
C
      DO 80 I1=1,NZ
        IF(DABS(AZZ(I1,I1)).GT.1.D-12) GO TO 50
        IF(I1.EQ.NZ) GO TO 50
        I1P = I1+1
        IP1V=I1
        PMAX = DABS(AZZ(I1,I1))
        DO 30 I2=I1P,NZ
          IF(DABS(AZZ(I2,I1)).LT. PMAX) GO TO 30
          PMAX = DABS(AZZ(I2,I1))
          IP1V=I2
   30   CONTINUE
        IF(IP1V.EQ.I1) GO TO 50
        DO 40 I3=1,NZ
          AT1 = AZZ(I1,I3)
          AT2 = AZV(I1,I3)
          AZZ(I1,I3)=AZZ(IP1V,I3)
          AZV(I1,I3)=AZV(IP1V,I3)
          AZZ(IP1V,I3) = AT1
          AZV(IP1V,I3) = AT2
   40   CONTINUE
C
   50   CONTINUE
        AP1V = AZZ(I1,I1)
	  IF(DABS(AP1V).LT.1.D-13)WRITE(6,*)'MATRIX IS SINGULAR'
	  IF(DABS(AP1V).LT.1.D-13)RETURN
C
        DO 55 J1=1,NZ
          AZZ(I1,J1) = AZZ(I1,J1)/AP1V
          AZV(I1,J1) = AZV(I1,J1)/AP1V
   55   CONTINUE
        DO 70 I4=1,NZ
          IF(I4.EQ.I1)GO TO 70
          IF(DABS(AZZ(I4,I1)).LT.1.D-12)GO TO 70
          AP2V=AZZ(I4,I1)
        DO 60 J2=1,NZ
          IF(DABS(AZZ(I1,J2)).LT.1.D-12)GO TO 65
          AZZ(I4,J2)=AZZ(I4,J2)-AP2V*AZZ(I1,J2)
   65     CONTINUE
        AZV(I4,J2)=AZV(I4,J2)-AP2V*AZV(I1,J2)
   60   CONTINUE
   70   CONTINUE
   80 CONTINUE
C
      RETURN
      END
